;r-OCR by ronriel
;autoit-v3.2.12.0
;Tested in Windows XP SP2 with MS Office 2007

#Include <ScreenCapture.au3>
#include <GUIConstantsEx.au3>
#include <WindowsConstants.au3>
#Include <Misc.au3>
#include <Array.au3>

_Singleton("scriptxxx",0)
Opt("GUIOnEventMode",1)
Opt("WinTitleMatchMode", 4)
Opt("TrayOnEventMode",1)
Opt("TrayMenuMode",1)
HotKeySet("!r","ShowWin")

Local $v = 0, $X,$Y,$W,$H, $Image = @TempDir&"\ScreenCapture.jpg", $error = ObjEvent("AutoIt.Error","Error")

$GUI = GUICreate("", 90, 40,-1,-1,0x80880000,$WS_EX_TOOLWINDOW)
WinSetTrans($GUI,'',200)
$B1 = GUICtrlCreateButton("Read Region", 0, 0, 90, 20)
GUICtrlSetBkColor(-1,0xe6e6fa)
GUICtrlSetOnEvent(-1,"Capture")
$B2 = GUICtrlCreateButton("Read File", 0, 20, 90, 20)
GUICtrlSetBkColor(-1,0xe6e6fa)
GUICtrlSetOnEvent(-1,"Capture")

$GUI2 =  GUICreate("", 0 , 0 , 0, 0,  BitOR($WS_POPUP,$WS_BORDER), BitOR($WS_EX_TOPMOST, $WS_EX_TOOLWINDOW))
GUISetBkColor(0xe6e6fa,$GUI2)
WinSetTrans($GUI2,'',60)
GUISetState(@SW_HIDE)

$GUI3 = GUICreate("", 0 , 0 , 0,0 ,  BitOR($WS_POPUP,$WS_BORDER), BitOR($WS_EX_TOPMOST, $WS_EX_TOOLWINDOW))
GUISetBkColor(0xFF0000,$GUI3)
GUISetState(@SW_HIDE)

TrayCreateItem("Info")
TrayItemSetOnEvent(-1,'Ex')
$Exit = TrayCreateItem("Exit")
TrayItemSetOnEvent(-1,'Ex')
TraySetState()

Func ShowWin()
	If BitAND(WinGetState($GUI),2) Then
		GUISetState(@SW_HIDE,$GUI)
	Else
		$Mpos = MouseGetPos()
		WinMove($GUI,'',$Mpos[0]-45,$Mpos[1]-10)
		GUISetState(@SW_SHOW,$GUI)
	EndIf
EndFunc

Func Capture()
	_ScreenCapture_SetJPGQuality(100)
	If @GUI_CtrlId = $B1 Then
		GUISetState(@SW_HIDE,$GUI)
		GUISetState(@SW_SHOW,$GUI3)
		Do
			Sleep(10)
			ToolTip("Read Region")
			$c = MouseGetPos()
			WinMove($GUI3,"",$c[0]-2.5,$c[1]-2.5,5,5)
			If _IsPressed(01) Then
				ToolTip('')
				$C1 = MouseGetPos()
					Do
						Sleep(10)
						$C2 = MouseGetPos()
							If $C2[0] <> $C1[0] And $C2[1] <> $C1[1] Then 
								GUISetState(@SW_SHOW,$GUI2)
							EndIf
							If $C1[0] < $C2[0] Then 
								$X = $C1[0]
								$W = $C2[0] - $C1[0]
							Else
								$X = $C2[0]
								$W = $C1[0] - $C2[0]
							EndIf
							If $C1[1] < $C2[1] Then 
								$Y = $C1[1]
								$H = $C2[1] - $C1[1]
							Else
								$Y = $C2[1]
								$H = $C1[1] - $C2[1]
							EndIf
						WinMove($GUI2,"",$X,$Y,$W,$H)
						WinMove($GUI3,"",$c2[0]-2.5,$c2[1]-2.5,5,5)
					Until Not _IsPressed(01)
				$v = 1
			EndIf
		Until $v = 1
		$v = 0
		GUISetState(@SW_HIDE,$GUI2)
		GUISetState(@SW_HIDE,$GUI3)
		_ScreenCapture_Capture($Image,$x,$y,$x+$w,$y+$h)
	ElseIf @GUI_CtrlId = $B2 Then
		GUISetState(@SW_HIDE,$GUI)
		$Image = FileOpenDialog("Choose an Image File",@DesktopDir&"\","Images (*.jpg;*.bmp;*.gif;*.png;*.tif)")
		if @error then Return
	EndIf
	$OCR = OCR($Image)
	If @error then Return
	ClipPut(_ArrayToString($OCR," ",1))
	TrayTip("Info","Text saved to Clipboard",2,1)
EndFunc
	
Func OCR($Image)
	Local $Array[1], $Word
    $miDoc = ObjCreate("MODI.Document")
    $miDoc.Create($Image)
    If @error Then Return SetError(1)
    $miDoc.Ocr(9, True, True)
    If @error Then Return SetError(1)
    For $Word In $miDoc.Images(0).Layout.Words
        _ArrayAdd($Array,$Word.text)
    Next
    Return $Array
EndFunc

Func Error()
  Msgbox(0,"r-OCR","Error!")
Endfunc

Func Ex()
	If @TRAY_ID = $Exit Then 
		Exit
	Else
		MsgBox(0,"Info", "Press ALT+R to start."&@CRLF&@CRLF&"r-OCR"&@CRLF&"By: ronriel (ronriel@yahoo.com)")
	EndIf
EndFunc

While 1
Sleep(100000)
WEnd